<!--
  @description: 报表统计-平台运营情况-项目采购情况列表详情
  @Modifier: 肖文龙
  @routerPath:
  @date: 2021-01-30
-->
<template>
  <el-dialog
    v-dialogDrag
    :modal="false"
    :visible.sync="dialog"
    :close-on-click-modal="false"
    title="采购项目方式"
    width="840px"
  >
    <section class="clearfix">
      <el-form ref="searchForm" :model="searchForm" inline>
        <el-form-item label="采购方式">
          <el-select v-model="searchForm.tenderMethod" popper-class="el-select-reportChart" placeholder="请选择">
            <el-option
              v-for="item in bidAndprocForMethod"
              :key="item.typecode"
              :label="item.typename"
              :value="item.typecode"
            />
          </el-select>
        </el-form-item>
        <el-form-item class="fr">
          <el-button type="primary" round @click="search">
            查询
          </el-button>
          <el-button type="primary" round @click="resetForm('searchForm')">
            重置
          </el-button>
          <el-button type="primary" round @click="exportChange">
            导出
          </el-button>
        </el-form-item>
      </el-form>
    </section>
    <tableChart
      :height="height"
      class="echart-dom"
      :option="option"
    />
    <pagination :pagination-data="paginationData" @change="loadData" />
  </el-dialog>
</template>

<script>
/* api */
import { listProcurementMethodInfoPages, exportProcurementMethodInfoPages } from '@api/statisticalAnalysis/reportChart.js'
/* 公用方法*/
import { filterDictText, download, filterObj, restoreInitialValue } from '@/assets/js/utils'// 过滤空的key
/* 混合开发方法-参数字段*/
import { reportChartGroupMixin } from './../../mixins/reportChartGroup.js'
import { ListMixin } from '@/mixins/ListMixin'// 分页
/* 組件 */
import tableChart from './../../components/tableChart'// table列表渲染组件
import pagination from '@comp/common/pagination/pagination'// 分页

export default {
  name: 'ProjectProcMethodListDialog',
  components: {
    tableChart, // table列表渲染组件
    pagination // 分页
  },
  mixins: [ListMixin],
  data() {
    return {
      /* 字典信息-start */
      ...reportChartGroupMixin,
      /* 字典信息-end */
      height: '450px', // 高度
      dialog: false, // 弹窗状态
      // 查询条件
      searchForm: {
        tenderMethod: '' // 采购方式
      },
      // 全局的查询条件
      searchChartData: {
      },
      option: {
        // 非TOP排序
        showIndexTOP: false,
        // 标题
        thead: [
          { lable: '采购方式', prop: 'tenderMethod', align: 'left' },
          { lable: '已完成项目数量（个）', prop: 'endProjectNumbers', align: 'center' },
          { lable: '已完成项目完成金额（万元）', prop: 'endProjectMoney', align: 'center' }
        ],
        // 渲染数据
        data: []
      }
    }
  },
  methods: {
    /**
     * 打开弹窗
     *  @param {searchChartData} Object 全局的查询条件
    */
    open(searchChartData) {
      this.searchChartData = searchChartData
      this.dialog = true
      this.loadData()
    },
    // 获取数据
    loadData() {
      this.option.data = []
      const data = this.getParams()
      listProcurementMethodInfoPages(data).then(res => {
        this.paginationData.total = res.data.total
        res.data.records.forEach(item => {
          this.option.data.push({
            ...item,
            tenderMethod: filterDictText(this.bidAndprocForMethod, item.tenderMethod)

          })
        })
      })
    },
    // 查询条件
    getParams() {
      this.searchForm = {
        ...this.searchForm,
        ...this.searchChartData
      }
      const param = Object.assign({}, this.searchForm)
      param.pageNo = this.paginationData.pageNo
      param.pageSize = this.paginationData.pageSize
      return filterObj(param)// 过滤空的key
    },
    // 搜索
    search() {
      this.paginationData.pageNo = 1
      this.paginationData.pageSize = 10
      this.loadData()
    },
    // 重置
    resetForm(formName) {
      restoreInitialValue(this.searchForm)
      this.search()
    },
    // 导出
    exportChange() {
      const data = { ...this.searchForm }
      exportProcurementMethodInfoPages(data).then(res => {
        download(res, '项目采购情况列表详情.xls')
      })
    }
  }
}
</script>

<style scoped lang="less">
</style>
